using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameOptionsController : MonoBehaviour
{
    [SerializeField]
    public List<GameObject> otherUIs;
    [SerializeField] private GameObject GameOptionsUI;

    private void Start()
    {
        GameOptionsUI.SetActive(false);

        QualitySettings.vSyncCount = 1;
    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetKeyDown(KeyCode.Escape)) ToggleGameOptionsUI();
    }

    private void ToggleGameOptionsUI()
    {
        GameOptionsUI.SetActive(!GameOptionsUI.activeSelf);

        if (!GameOptionsUI.activeSelf) return;

        for (int i = 0; i < otherUIs.Count; i++)
        {
            otherUIs[i].SetActive(false);
        }
    }
}
